#ifndef IMAGE_FILTER_H
#define IMAGE_FILTER_H

#include "filter.h"

namespace Konvert
{
void addImageFilters(QPtrList<Filter> &list);

//----------------------------------------------------------------------------
class ImageKDEFilter : public Filter
{
  Q_OBJECT
public:
  ImageKDEFilter();

private:
  virtual void startInternal(const QString &source, const MimeType &sourceType,
                             const QString &dest, const MimeType &destType);
  virtual BasicMimeTypeList getSupportedMimetypes(IOType type) const;
};

//----------------------------------------------------------------------------
class ImageMagickFilter : public MultiTypeProcessFilter
{
  Q_OBJECT
public:
  ImageMagickFilter(const Data &data, Action action, FileType type);
  
  static const CodeData CODE_DATA[];
private:
  FileType _type;
  
  virtual QStringList extractCodes(IOType type, const QStringList &lines) const;
  virtual bool isAccepted(IOType type, const MimeType &mimetype) const;
};

//----------------------------------------------------------------------------
// Note: 'convert' is converting from Image and Publishing types
class GenericConvertFilter : public ImageMagickFilter
{
  Q_OBJECT
public:
  GenericConvertFilter(FileType type);
  
private:
  static const Data DATA;
  
  virtual QStringList args(const QString &source, const MimeType &sourceType,
                           const QString &dest, const MimeType &destType) const;
};

//----------------------------------------------------------------------------
class IdentifyFilter : public ImageMagickFilter
{
  Q_OBJECT
public:
  IdentifyFilter();
  
private:
  static const Data DATA;
  
  virtual QStringList args(const QString &source, const MimeType &sourceType,
                           const QString &dest, const MimeType &destType) const;
};

}

#endif
