#ifndef PUBLISH_FILTER_H
#define PUBLISH_FILTER_H

#include "filter.h"

namespace Konvert
{
void addPublishingFilters(QPtrList<Filter> &list);

//----------------------------------------------------------------------------
class GSPublishingFilter : public MultiTypeProcessFilter
{
  Q_OBJECT
public:
  GSPublishingFilter();
  
private:
  static const Data DATA;
  static const CodeData SOURCE_CODE_DATA[], DEST_CODE_DATA[];
  
  virtual QStringList args(const QString &source, const MimeType &sourceType,
                           const QString &dest, const MimeType &destType) const;
  virtual QStringList extractCodes(IOType type, const QStringList &lines) const;
};

//----------------------------------------------------------------------------
class PublishingFilter : public ProcessFilter
{
  Q_OBJECT
public:
  enum { Nb_Types = 5 };
  PublishingFilter(uint i);
  
private:
  typedef const char *MimeTypeList[10];
  struct ExtData {
    Process::Data data;
    Process::ArgData args;
    MimeTypeList mimetypes[Nb_IOTypes];
  };
  const ExtData &_data;
  static const ExtData DATA[Nb_Types];

  virtual BasicMimeTypeList findSupportedMimetypes(IOType type,
                                                   const QStringList &lines) const;
  virtual QStringList args(const QString &source, const MimeType &sourceType,
                           const QString &dest, const MimeType &destType) const;
};

}

#endif
